Event.observe(window, 'load', prepareForAdminConsole, false);
Event.observe(window, 'load', prepareForDragAndDrop, false);
Event.observe(window, 'load', prepareForPop, false);
Event.observe(window, 'load', prepareForGlobalHandlers, false);
Event.observe(window, 'load', setListeners, false);

function prepareForPop() {
    var pops = $A(document.getElementsByClassName('pop'));
    pops.each(function (pop) {
        if (pop.id != 'newPop') {
            new InPlacePropertyEditor(pop,
                '<span tal:replace="page:%/layout.updateProperties.do"></span>', {
                    loadTextURL: '<span tal:replace="page:%/layout.editProperties.do"></span>'
                });
        }
        Event.observe(pop, 'mouseover', popMouseoverListener.bindAsEventListener(pop));
        Event.observe(pop, 'mouseout', popMouseoutListener.bindAsEventListener(pop));
    });
}

function popMouseoverListener() {
    this.setStyle({cursor: 'move'});
}

function popMouseoutListener() {
    this.setStyle({cursor: 'auto'});
}

function prepareForGlobalHandlers() {
    var myGlobalHandlers = {
        onLoading: function () {
            Element.show('admin-indicator');
        },
        onComplete: function () {
            if (Ajax.activeRequestCount == 0) {
                setTimeout(function () {
                    Element.hide('admin-indicator');
                }, 100);
            }
        }
    };
    Ajax.Responders.register(myGlobalHandlers);
}

function prepareForAdminConsole() {
    var body = document.getElementsByTagName('body')[0];
    var element = document.createElement('div');
    element.id = 'admin-console';
    body.appendChild(element);

    var myAjax = new Ajax.Updater(
        'admin-console',
        '<span tal:replace="page:%/layout.console.do"></span>',
        {
            asynchronous: false,
            method: 'get'
        }
    );
}

function setListeners() {
/*    var panes = $A(document.getElementsByClassName('pane'));
    panes.each(function(pane) {
        Event.observe(pane, 'click', doSelectNewPop, false);
    });*/
}

function doSave() {
    var url = '<span tal:replace="page:%/layout.update.do"></span>';
    var postBody = constructPostBody();

    var myAjax = new Ajax.Request(
        url,
        {
            asynchronous: true,
            method: 'post',
            postBody: postBody
        }
    );
}

function constructPostBody() {
    var panes = $A(document.getElementsByClassName('pane'));
    var postBody = '';
    var delim = '';
    panes.each(function (pane) {
        if (pane.id) {
            postBody += delim + encodeURIComponent(pane.id)
                + '=';
            delim = '&';

            var pops = $A(pane.childNodes);
            var body = '';
            var dlm = '';
            pops.each(function (pop) {
                if (pop.id) {
                    body += dlm + pop.id;
                    dlm = ',';
                }
            });

            postBody += encodeURIComponent(body);
        }
    });
    return postBody;
}

function doCancel() {
    window.location.reload();
}

function findElementByClassName(element, className) {
    while (element.parentNode && (!element.className ||
            !element.className.match(
            new RegExp("(^|\\s)" + className + "(\\s|$)")))) {
        element = element.parentNode;
    }
    return element;
}

function prepareForDragAndDrop() {
    var pops = $A(document.getElementsByClassName('pop'));
    pops.each(function(pop) {
        if (pop.id) {
            new Draggable(pop.id, {
                revert: true,
                onEnd: function () {
                    this.setStyle({
                        borderColor: '#FFFFFF',
                        borderStyle: 'none',
                        borderWidth: '0px'
                    });
                }.bindAsEventListener(pop)
            });
        }
    });

    var panes = $A(document.getElementsByClassName('pane'));
    panes.each(function (pane) {
        Droppables.add(pane.id, {
            accept: 'pop',
            onHover: function (pop, targetElement) {
                processHighlight(
                    findElementByClassName(targetElement, 'pane'));
            },
            onDrop: function (pop, targetElement) {
                disableHighlight(targetElement);
                targetElement.appendChild(pop);
                if (pop.id == 'newPop') {
                    Element.hide(pop);
                    location.href
                        = '<span tal:replace="page:%/layout.select.do"></span>'
                        + '?paneId=' + encodeURIComponent(targetElement.id)
                        + '&start=' + encodeURIComponent(location.href);
                } else {
                    doSave();
                }
            }
        });
    });

    Droppables.add('popTrash', {
        accept: 'pop',
        onHover: function (pop) {
            processHighlight($('popTrash'));
        },
        onDrop: function (pop) {
            if (pop.id != 'newPop') {
                var popTrash = $('popTrash');
                popTrash.appendChild(pop);
                popTrash.removeChild(pop);
                disableHighlight(popTrash);
                doSave();
            }
        }
    });
}

function processHighlight(dropElement) {
    var panes = $A(document.getElementsByClassName('pane'));
    panes.push($('popTrash'));
    panes.each(function (pane) {
        if (pane == dropElement) {
            enableHighlight(pane);
        } else {
            disableHighlight(pane);
        }
    });
}

function enableHighlight(element) {
    element.style.borderStyle = 'dotted';
    element.style.borderWidth = '2px';
    element.style.borderColor = '#cccc66';
}

function disableHighlight(element) {
    element.style.borderStyle = 'none';
}

InPlacePropertyEditor = Class.create();
InPlacePropertyEditor.defaultHighlightColor = "#FFFF99";
InPlacePropertyEditor.prototype = {
  initialize: function(element, url, options) {
    this.url = url;
    this.element = $(element);

    this.options = Object.extend({
      okButton: true,
      okText: "ok",
      cancelLink: true,
      cancelText: "cancel",
      savingText: "Saving...",
      clickToEditText: "Double click to edit",
      okText: "ok",
      rows: 1,
      onComplete: function(transport, element) {
        new Effect.Highlight(element, {startcolor: this.options.highlightcolor});
      },
      onFailure: function(transport) {
        alert("Error communicating with the server: " + transport.responseText.stripTags());
      },
      callback: function(form) {
        return Form.serialize(form);
      },
      handleLineBreaks: true,
      loadingText: 'Loading...',
      savingClassName: 'inplaceeditor-saving',
      loadingClassName: 'inplaceeditor-loading',
      formClassName: 'inplaceeditor-form',
      highlightcolor: Ajax.InPlaceEditor.defaultHighlightColor,
      highlightendcolor: "#FFFFFF",
      externalControl: null,
      submitOnBlur: false,
      ajaxOptions: {},
      evalScripts: false
    }, options || {});

    if(!this.options.formId && this.element.id) {
      this.options.formId = this.element.id + "-inplaceeditor";
      if ($(this.options.formId)) {
        // there's already a form with that name, don't specify an id
        this.options.formId = null;
      }
    }

    if (this.options.externalControl) {
      this.options.externalControl = $(this.options.externalControl);
    }

    this.originalBackground = Element.getStyle(this.element, 'background-color');
    if (!this.originalBackground) {
      this.originalBackground = "transparent";
    }

    this.originalBorderColor = Element.getStyle(this.element, 'border-color');
    if (!this.originalBorderColor) {
      this.originalBorderColor = "#ffffff";
    }
    this.originalBorderStyle = Element.getStyle(this.element, 'border-style');
    if (!this.originalBorderStyle) {
      this.originalBorderStyle = "none";
    }
    this.originalBorderWidth = Element.getStyle(this.element, 'border-width');
    if (!this.originalBorderWidth) {
      this.originalBorderWidth = "0px";
    }

    this.element.title = this.options.clickToEditText;

    this.onclickListener = this.enterEditMode.bindAsEventListener(this);
    this.mouseoverListener = this.enterHover.bindAsEventListener(this);
    this.mouseoutListener = this.leaveHover.bindAsEventListener(this);
    Event.observe(this.element, 'dblclick', this.onclickListener);
    Event.observe(this.element, 'mouseover', this.mouseoverListener);
    Event.observe(this.element, 'mouseout', this.mouseoutListener);
    if (this.options.externalControl) {
      Event.observe(this.options.externalControl, 'dblclick', this.onclickListener);
      Event.observe(this.options.externalControl, 'mouseover', this.mouseoverListener);
      Event.observe(this.options.externalControl, 'mouseout', this.mouseoutListener);
    }

    this.onkeypressVariantListener = this._onkeypressVariantListener.bindAsEventListener(this);
  },
  enterEditMode: function(evt) {
    if (this.saving) return;
    if (this.editing) return;
    this.editing = true;
    this.onEnterEditMode();
    if (this.options.externalControl) {
      Element.hide(this.options.externalControl);
    }
    Element.hide(this.element);
    this.createForm();
    this.element.parentNode.insertBefore(this.form, this.element);
    if (!this.options.loadTextURL) Field.scrollFreeActivate(this.editField);
    // stop the event to avoid a page refresh in Safari
    if (evt) {
      Event.stop(evt);
    }
    return false;
  },
  createForm: function() {
    this.form = document.createElement("form");
    this.form.id = this.options.formId;
    Element.addClassName(this.form, this.options.formClassName)
    this.form.onsubmit = this.onSubmit.bind(this);

    this.createEditField();

    if (this.options.textarea) {
      var br = document.createElement("br");
      this.form.appendChild(br);
    }

    if (this.options.okButton) {
      okButton = document.createElement("input");
      okButton.type = "submit";
      okButton.value = this.options.okText;
      okButton.className = 'editor_ok_button';
      this.form.appendChild(okButton);
    }

    if (this.options.cancelLink) {
      cancelLink = document.createElement("a");
      cancelLink.href = "#";
      cancelLink.appendChild(document.createTextNode(this.options.cancelText));
      cancelLink.onclick = this.onclickCancel.bind(this);
      cancelLink.className = 'editor_cancel';
      this.form.appendChild(cancelLink);
    }
  },
  hasHTMLLineBreaks: function(string) {
    if (!this.options.handleLineBreaks) return false;
    return string.match(/<br/i) || string.match(/<p>/i);
  },
  convertHTMLLineBreaks: function(string) {
    return string.replace(/<br>/gi, "\n").replace(/<br\/>/gi, "\n").replace(/<\/p>/gi, "\n").replace(/<p>/gi, "");
  },
  createEditField: function () {
    var obj = this;
    this.options.textarea = false;
    var div = document.createElement("div");
    div.innerHTML = this.options.loadingText;
    div.style.backgroundColor = this.options.highlightcolor;
    if (this.options.submitOnBlur) {
      div.onblur = this.onSubmit.bind(this);
    }
    this.editField = div;
    this.loadExternalText();
    this.form.appendChild(this.editField);
  },
  getText: function() {
    return this.element.innerHTML;
  },
  loadExternalText: function() {
    this.editField.disabled = true;
    new Ajax.Request(
      this.options.loadTextURL,
      {
        asynchronous: true,
        parameters: 'popId=' + encodeURIComponent(this.element.id)
            + '&start=' + encodeURIComponent(location.href),
        onComplete: this.completeLoadForm.bind(this)
      });
  },
  onLoadedExternalText: function(transport) {
    Element.removeClassName(this.form, this.options.loadingClassName);
    this.editField.disabled = false;
    this.editField.value = transport.responseText.stripTags();
    Field.scrollFreeActivate(this.editField);
  },
  onclickCancel: function() {
    this.onComplete();
    this.leaveEditMode();
    return false;
  },
  onFailure: function(transport) {
    this.options.onFailure(transport);
    if (this.oldInnerHTML) {
      this.element.innerHTML = this.oldInnerHTML;
      this.oldInnerHTML = null;
    }
    return false;
  },
  onSubmit: function() {
    // onLoading resets these so we need to save them away for the Ajax call
    var form = this.form;
    var value = this.editField.value;

    // do this first, sometimes the ajax call returns before we get a chance to switch on Saving...
    // which means this will actually switch on Saving... *after* we've left edit mode causing Saving...
    // to be displayed indefinitely
    this.onLoading();

    new Ajax.Updater(
      { success: this.element,
        // don't update on failure (this could be an option)
        failure: null },
      this.url, Object.extend({
        method: 'post',
        postBody: this.options.callback(form, value),
        onComplete: this.onComplete.bind(this),
        onFailure: this.onFailure.bind(this)
      }, this.options.ajaxOptions));
    // stop the event to avoid a page refresh in Safari
    if (arguments.length > 1) {
      Event.stop(arguments[0]);
    }
    return false;
  },
  onLoading: function() {
    this.saving = true;
    this.removeForm();
    this.leaveHover();
    this.showSaving();
  },
  showSaving: function() {
    this.oldInnerHTML = this.element.innerHTML;
    this.element.innerHTML = this.options.savingText;
    Element.addClassName(this.element, this.options.savingClassName);
    this.element.style.backgroundColor = this.originalBackground;
    Element.show(this.element);
  },
  removeForm: function() {
    if(this.form) {
      if (this.form.parentNode) Element.remove(this.form);
      this.form = null;
    }
  },
  enterHover: function() {
    if (this.saving) return;
    this.element.setStyle({
      borderColor: '#666666',
      borderStyle: 'dashed',
      borderWidth: '2px'
    });
    if (this.effect) {
      this.effect.cancel();
    }
    Element.addClassName(this.element, this.options.hoverClassName);
  },
  leaveHover: function() {
    Element.removeClassName(this.element, this.options.hoverClassName);
    if (this.saving) return;
    this.element.setStyle({
      borderColor: this.originalBorderColor,
      borderStyle: this.originalBorderStyle,
      borderWidth: this.originalBorderWidth
    });
  },
  leaveEditMode: function() {
    Element.removeClassName(this.element, this.options.savingClassName);
    this.removeForm();
    this.leaveHover();
    this.element.style.backgroundColor = this.originalBackground;
    Element.show(this.element);
    if (this.options.externalControl) {
      Element.show(this.options.externalControl);
    }
    this.editing = false;
    this.saving = false;
    this.oldInnerHTML = null;
    this.onLeaveEditMode();
  },
  onComplete: function(transport) {
    this.leaveEditMode();
    this.options.onComplete.bind(this)(transport, this.element);
  },
  onEnterEditMode: function() {},
  onLeaveEditMode: function() {},
  dispose: function() {
    if (this.oldInnerHTML) {
      this.element.innerHTML = this.oldInnerHTML;
    }
    this.leaveEditMode();
    Event.stopObserving(this.element, 'dblclick', this.onclickListener);
    Event.stopObserving(this.element, 'mouseover', this.mouseoverListener);
    Event.stopObserving(this.element, 'mouseout', this.mouseoutListener);
    if (this.options.externalControl) {
      Event.stopObserving(this.options.externalControl, 'dblclick', this.onclickListener);
      Event.stopObserving(this.options.externalControl, 'mouseover', this.mouseoverListener);
      Event.stopObserving(this.options.externalControl, 'mouseout', this.mouseoutListener);
    }
  },
  _onkeypressVariantListener: function (e) {
    if (e.keyCode == Event.KEY_RETURN) {
      Event.stop(e);

      var variant = Event.element(e).value;
      this.editField.disabled = true;
      new Ajax.Request(
        this.options.loadTextURL,
        {
          asynchronous: true,
          parameters: 'popId=' + encodeURIComponent(this.element.id)
              + '&variant=' + encodeURIComponent(variant),
          onComplete: this.completeLoadForm.bind(this)
        });
    }
  },
  completeLoadForm: function (transport) {
    this.editField.innerHTML = transport.responseText;
    this.editField.disabled = false;
    Field.scrollFreeActivate(this.editField);

    var elements = $A(document.getElementsByClassName('expand', this.editField));
    elements.each(function (element) {
      Event.observe(element, 'click', this.expandField.bindAsEventListener(this));
    }.bind(this));

    var variantElement = $A(document.getElementsByClassName('variant', this.editField)).shift();
    if (variantElement) {
      Event.observe(variantElement, "keypress", this.onkeypressVariantListener);
      Field.focus(variantElement);
    }
  },
  expandField: function (e) {
    var target = Event.element(e);
    var field = $(target.id.substring(0, target.id.length - 7));
    var newField;
    if (target.value == '+') {
      newField = document.createElement('textarea');
      newField.rows = 10;
      newField.style.verticalAlign = 'top';
      newField.innerHTML = field.value;
      target.value = '-';
    } else {
      newField = document.createElement('input');
      newField.type = 'text';
      newField.value = field.innerHTML;
      target.value = '+';
    }
    newField.id = field.id;
    newField.name = field.name;
    newField.style.width = field.style.width;
    field.parentNode.insertBefore(newField, field);
    field.parentNode.removeChild(field);
  }
};
